﻿--[[
Name: PratAddonMsgs
Revision: $Revision: 24018 $
Author(s): Sylvanaar
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#AddonMsgs
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that toggles showing hidden addon messages on and off (default=off).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratAddonMsgs")

L:RegisterTranslations("enUS", function() return {
    ["AddonMessages"] = true,
    ["Chat window addon message options."] = true,
    ["Show Addon Messages"] = true,
    ["Toggle showing hidden addon messages on and off for each window."] = true,
    ["Chat%dAddonMsgsShow"] = true,
    ["Toggle showing hidden addon messages on and off for chat window %d."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
    ["show_name"] = "Show Addon Messages",
    ["show_desc"] = "Toggle showing hidden addon messages on and off for each window.",
    ["show_perframename"] = "Chat%dAddonMsgsShow",
    ["show_perframedesc"] = "Toggle showing hidden addon messages on and off for chat window %d.",
} end)

-- L:RegisterTranslations("zhCN", function() return {
--     ["AddonMsgs"] = "插件信息",
--     ["AddonMsgs options."] = "插件信息设置",
--     ["Toggle"] = "选择",
--     ["Toggle the module on and off."] = "选择打开或关闭",
--     ["Show"] = "显示",
--     ["Toggle showing hidden addon messages for each window."] = "选择是否在每个窗口显示插件信息",
--     ["Chat%dAddonMsgsShow"] = "在窗口%d显示插件信息",
--     ["Toggles showing hidden addon messages on and off for chat window %d."] = "选择是否在聊天窗口%d显示隐藏的插件信息."
-- } end)
-- 
-- L:RegisterTranslations("koKR", function() return {
-- 	["AddonMessages"] = "애드온메세지",
-- 	["Chat window addon message options."] = "대화창 애드온 메세지 설정입니다.",
-- 	["Show Addon Messages"] = "애드온 메세지 표시",
-- 	["Toggle showing hidden addon messages on and off for each window."] = "각각의 대화창에 숨겨진 애드온 메세지를 표시합니다.",
-- 	["Chat%dAddonMsgsShow"] = "대화창%d애드온메세지표시",
-- 	["Toggle showing hidden addon messages on and off for chat window %d."] = "대화창 %d에 숨겨진 애드온 메세지를 표시합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- 	["show_name"] = "애드온 메세지 표시",
-- 	["show_desc"] = "각각의 대화창에 숨겨진 애드온 메세지를 표시합니다.",
-- 	["show_perframename"] = "대화창%d애드온메세지표시",
-- 	["show_perframedesc"] = "대화창%d에 숨겨진 애드온 메세지를 표시합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["AddonMsgs"] = "插件訊息",
--     ["AddonMsgs options."] = "插件訊息選項",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉",
--     ["Show"] = "顯示",
--     ["Toggle showing hidden addon messages for each window."] = "切換是否在每個視窗顯示插件訊息",
--     ["Chat%dAddonMsgsShow"] = "在視窗%d顯示插件訊息",
--     ["Toggles showing hidden addon messages on and off for chat window %d."] = "選擇是否在聊天視窗%d顯示隱藏的插件信息。"
-- } end)
--
-- L:RegisterTranslations("esES", function() return {
--     ["AddonMsgs"] = "Mensajes de Accesorio",
--     ["AddonMsgs options."] = "Opciones de Mensajes de Accesorio",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva el m\195\179dulo.",
--     ["Show"] = "Mostrar",
--     ["Toggle showing hidden addon messages for each window."] = "Determina si se muestran los mensajes ocultos de accesorio para cada ventana.",
--     ["Chat%dAddonMsgsShow"] = "Mensajes de Accesorio del Chat%d",
--     ["Toggles showing hidden addon messages on and off for chat window %d."] = "Determina si se muestran los mensajes de accesorio para la ventana de chat %d."
-- } end)
--
-- L:RegisterTranslations("deDE", function() return {
--     ["AddonMsgs"] = "Addon Nachrichten",
--     ["AddonMsgs options."] = "Addon Nachrichten Optionen",
--     ["Toggle"] = "Einschalten",
--     ["Toggle the module on and off."] = "Schaltet das Modul an und aus",
--     ["Show"] = "Zeige",
--     ["Toggle showing hidden addon messages for each window."] = "Swicht das anzeigen von verborgenen Nachrichten f\195\188r jedes Fenster",
--     ["Chat%dAddonMsgsShow"] = "Chat %d Addon Nachrichten anzeigen",
--     ["Toggles showing hidden addon messages on and off for chat window %d."] = "Switcht das Anzeigen von verborgenen Addon Nachrichten f\195\188r Chat Fenster %d.",
-- } end)

Prat_AddonMsgs = Prat:NewModule(Prat:RequestModuleName("PratAddonMsgs"))
Prat_AddonMsgs.revision = tonumber(string.sub("$Revision: 24018 $", 12, -3))

Prat_AddonMsgs.defaultDB = {
    on = false,
    show = {false, false, false, false, false, false, false},
}

--Prat_AddonMsgs.moduleOptions = {}
Prat_AddonMsgs.toggleOptions = { show={} }

Prat_AddonMsgs.moduleName = L["AddonMessages"]
Prat_AddonMsgs.moduleDesc = L["Chat window addon message options."]

local cat = Prat.Categories

Prat_AddonMsgs.Categories = { cat.DEV, cat.INFO }


function Prat_AddonMsgs:OnModuleEnable()
    self:RegisterEvent("CHAT_MSG_ADDON")
end

function CLR:arg1(text) return self:Colorize("ffff40", text) end
function CLR:arg2(text) return self:Colorize("a0a0a0", text) end
function CLR:arg3(text) return self:Colorize("40ff40", text) end
function CLR:arg4(text) return self:Colorize("4040ff", text) end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

function Prat_AddonMsgs:CHAT_MSG_ADDON()
    for i=1,NUM_CHAT_WINDOWS do
		if self.db.profile.show[i] then
			getglobal("ChatFrame"..i):AddMessage("["..CLR:arg1(arg1).."]["..CLR:arg2(arg2).."]["..CLR:arg3(arg3).."]["..CLR:arg4(arg4).."]")
		end
    end
end
