﻿--[[
Name: PratChatButtons
Revision: $Revision: 24018 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
           Sylvanaar
Inspired by: idChat2_Buttons by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#Buttons
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that toggles the chat menu and chat window buttons on and off (default=off).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratChatButtons")

L:RegisterTranslations("enUS", function() return {
    ["ChatButtons"] = true,
    ["Chat window menu and buttons options."] = true,
    ["menu_name"] = "Menu",
    ["menu_desc"] = "Menu for this module.",
    ["chatmenu_name"] = "Show Chat Menu",
    ["chatmenu_desc"] = "Toggles chat menu on and off.",
    ["chatbutton_name"] = "Show Chat Buttons",
    ["chatbutton_desc"] = "Toggle chat buttons on and off for each chat window.",
    ["chatbutton_perframename"] = "Chat%dButtons",
    ["chatbutton_perframedesc"] = "Toggles buttons on and off for chat window %d.",
    ["position_name"] = "Set Position",
    ["position_desc"] = "Sets position of buttons for all chat windows.",
    ["alpha_name"] = "Set Alpha",
    ["alpha_desc"] = "Sets alpha of buttons for all chat windows.",
    ["reminder_name"] = "Show ScrollDown Reminder",
    ["reminder_desc"] = "Show reminder button when not at the bottom of a chat window.",
    ["Default"] = true,
    ["Right, Inside Frame"] = true,
    ["Right, Outside Frame"] = true,
} end)

-- L:RegisterTranslations("zhCN", function() return {
--     ["Buttons"] = "按钮",
--     ["Chat window menu and buttons options."] = "聊天窗口菜单及按钮选项。",
--     ["ChatMenu"] = "聊天菜单",
--     ["Toggles chat menu on and off."] = "显示聊天菜单打开与关闭。",
--     ["ChatButtons"] = "聊天按钮",
--     ["Toggle chat windows buttons on and off."] = "切换显示聊天按钮打开与关闭。",
--     ["Chat%dButtons"] = "聊天%d按钮",
--     ["Toggles buttons on and off for chat window %d."] = "显示第 %d 聊天窗口按钮。",
--     ["Show Reminder Button"] = "显示提示按钮",
--     ["Show reminder button when not at bottom of chat window."] = "聊天窗口不在底部时显示提示按钮。",
--     ["Toggle"] = "切换",
--     ["Toggle the module on and off."] = "切换此模块打开与关闭。",
-- } end)
-- 
-- L:RegisterTranslations("koKR", function() return {
--     ["ChatButtons"] = "대화버튼",
--     ["Chat window menu and buttons options."] = "대화창 메뉴와 버튼을 설정합니다.",
--     ["menu_name"] = "메뉴",
--     ["menu_desc"] = "이 모듈에 대한 메뉴입니다.",
--     ["chatmenu_name"] = "대화 메뉴 표시",
--     ["chatmenu_desc"] = "대화 메뉴를 표시합니다.",
--     ["chatbutton_name"] = "대화 버튼 표시",
--     ["chatbutton_desc"] = "각각의 대화창에 대화 버튼을 표시합니다.",
--     ["chatbutton_perframename"] = "대화창%d버튼",
--     ["chatbutton_perframedesc"] =  "대화창 %d에 대한 버튼을 표시합니다.",
--     ["position_name"] = "위치 설정",
--     ["position_desc"] = "모든 대화창에 대한 버튼의 위치를 설정합니다.",
--     ["alpha_name"] = "투명도 설정",
--     ["alpha_desc"] = "모든 대화창에 대한 버튼의 투명도를 설정합니다.",
--     ["reminder_name"] = "스크롤 버튼 표시",
--     ["reminder_desc"] = "대화창의 하단이 아니면 스크롤 버튼을 표시합니다.",
--     ["Default"] = "기본",
--     ["Right, Inside Frame"] = "우측, 창 내부",
--     ["Right, Outside Frame"] = "우측, 창 외부",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["Buttons"] = "按鈕",
--     ["Chat window menu and buttons options."] = "聊天視窗選單及按鈕選項。",
--     ["ChatMenu"] = "聊天選單",
--     ["Toggles chat menu on and off."] = "顯示聊天選單打開與關閉。",
--     ["ChatButtons"] = "聊天按鈕",
--     ["Toggle chat windows buttons on and off."] = "切換顯示聊天按鈕打開與關閉。",
--     ["Chat%dButtons"] = "聊天%d按鈕",
--     ["Toggles buttons on and off for chat window %d."] = "顯示第 %d 聊天視窗按鈕。",
--     ["Show Reminder Button"] = "顯示提示按鈕",
--     ["Show reminder button when not at bottom of chat window."] = "聊天視窗不在底部時顯示提示按鈕。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
--
-- L:RegisterTranslations("esES", function() return {
--     ["Buttons"] = "Botones",
--     ["Chat window menu and buttons options."] = "Opciones del men\195\186 de la ventana de chat y botones",
--     ["ChatMenu"] = "Men\195\186 de Chat",
--     ["Toggles chat menu on and off."] = "Activa y desactiva el men\195\186 de chat",
--     ["ChatButtons"] = "Botones de Chat",
--     ["Toggle chat windows buttons on and off."] = "Activa y desactiva los botones de las ventanas de chat",
--     ["Chat%dButtons"] = "Botones del Chat %d",
--     ["Toggles buttons on and off for chat window %d."] = "Activa y desactiva los botones de la ventana de chat %d",
--     ["Show Reminder Button"] = "Mostrar Bot\195\179n de Recordatorio",
--     ["Show reminder button when not at bottom of chat window."] = "Muestra el bot\195\179n de recordatorio cuando no est\195\161s en la parte inferior de una ventana de chat.",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo",
--     ["Chat Buttons On Frame"] = "Botones de Chat en el Marco",
--     ["Show the chat buttons on the inside edge of the chat frame"] = "Muestra los botones de chat dentro del marco de chat",
--     ["Show Buttons On Right"] = "Mostrar Botones en la Derecha",
--     ["Show the chat buttons on the right side instead of the left"] = "Muestra los botones de chat en la derecha en vez de en la izquierda",
-- } end)
--
-- L:RegisterTranslations("deDE", function() return {
--     ["Buttons"] = "Buttons",
--     ["Chat window menu and buttons options."] = "Chat Fenster Men\195\188 und Button Optionen.",
--     ["ChatMenu"] = "Chat Men\195\188",
--     ["Toggles chat menu on and off."] = "Swicht das Chat Men\195\188 an und aus.",
--     ["ChatButtons"] = "Chat Buttons",
--     ["Toggle chat windows buttons on and off."] = "Swicht die Chat Fenster Buttons an und aus.",
--     ["Chat%dButtons"] = "Chat %d Buttons",
--     ["Toggles buttons on and off for chat window %d."] = "Swicht die Buttons an und aus f\195\188r das Chatfenster %d.",
--     ["Show Reminder Button"] = "Zeige Erinnerungs Button",
--     ["Show reminder button when not at bottom of chat window."] = "Zeige den Erinnerungs Button wenn man nicht am Ende des Chattextes ist.",
--     ["Toggle"] = "Einschalten",
--     ["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
--     ["Chat Buttons On Frame"] = "Chat Buttons auf dem Fenster",
--     ["Show the chat buttons on the inside edge of the chat frame"] = "Zeige die Chatbuttons auf dem inneren Rand des Chatfensters.",
--     ["Show Buttons On Right"] = "Zeige Buttons rechts",
--     ["Show the chat buttons on the right side instead of the left"] = "Zeige die Chatbuttons auf der rechten Seite anstatt der linken",
-- } end)

Prat_ChatButtons = Prat:NewModule(Prat:RequestModuleName("PratChatButtons"))

Prat_ChatButtons.revision = tonumber(string.sub("$Revision: 24018 $", 12, -3))

Prat_ChatButtons.status = "TAINT"

Prat_ChatButtons.defaultDB = {
    on = true,
    chatmenu = false,
    chatbutton = {false, false, false, false, false, false, false},
    position = "DEFAULT",
    alpha = 1.0,
    reminder = false,
}

local cat = Prat.Categories
Prat_ChatButtons.Categories = { cat.BUTTON, cat.FRAME }

Prat_ChatButtons.toggleOptions = {
    chatmenu = 150,
    chatbutton = {},
    position_options = {["DEFAULT"] = L["Default"], ["RIGHTINSIDE"] = L["Right, Inside Frame"], ["RIGHTOUTSIDE"] = L["Right, Outside Frame"]},
    alpha = {type="range", min=0.1, max=1, step=.1, order=180},
    reminder = 190
}
Prat_ChatButtons.moduleOptions = {}

Prat_ChatButtons.moduleName = L["ChatButtons"]
Prat_ChatButtons.moduleDesc = L["Chat window menu and buttons options."]

function Prat_ChatButtons:OnModuleEnable()
    -- fix menu ordering
    self.moduleOptions.args.chatbutton.order = 160
    self.moduleOptions.args.position.order = 170
    -- frames stub variable
    self.frames = {}
    self.frames.cfScrl = {}
    -- create reminder buttons
    for i = 1,NUM_CHAT_WINDOWS do
        self:MakeReminder(i)
    end
    -- wat da hook gon be?
    self:Hook("ChatFrame_OnUpdate", true)
end

function Prat_ChatButtons:OnModuleDisable()
    -- show chatmenu
    self:ChatMenu(true)
    -- show all the chatbuttons
    for i = 1,NUM_CHAT_WINDOWS do
        self:ChatButton(i,true)
    end
    -- stop hooking
    self:UnhookAll()
end

--[[------------------------------------------------
    Core Functions
------------------------------------------------]]--

function Prat_ChatButtons:ChatFrame_OnUpdate(elapsed)
    self.hooks["ChatFrame_OnUpdate"](elapsed)
    if this == SELECTED_CHAT_FRAME then
        self:ChatMenu(self.db.profile.chatmenu)
        for i = 1,NUM_CHAT_WINDOWS do
            self:ChatButton(i,self.db.profile.chatbutton[this:GetID()])
        end
    end
end

function Prat_ChatButtons:ChatMenu(visible)
    if visible then
        ChatFrameMenuButton:Show()
    else
        ChatFrameMenuButton:Hide()
    end
end

function Prat_ChatButtons:ChatButton(id,visible)
    local f = self.frames
    f.cf = getglobal("ChatFrame"..id)
    f.cfScrl.up = getglobal("ChatFrame"..id.."UpButton")
    f.cfScrl.down = getglobal("ChatFrame"..id.."DownButton")
    f.cfScrl.bottom = getglobal("ChatFrame"..id.."BottomButton")
    f.cfreminder = getglobal("ChatFrame"..id.."ScrollDownReminder")
    -- use special button positioning for chatframe1
    if id == 1 then
        ChatFrameMenuButton:ClearAllPoints()
        if self.db.profile.position == "RIGHTINSIDE" then
            ChatFrameMenuButton:SetPoint("TOP", f.cfScrl.up, "BOTTOM")
        else
            ChatFrameMenuButton:SetPoint("BOTTOM", f.cfScrl.up, "TOP")
        end
        ChatFrameMenuButton:SetAlpha(self.db.profile.alpha)
    end
    -- process the alpha of the buttons
    for _,v in pairs(f.cfScrl) do
        v:SetAlpha(self.db.profile.alpha)
    end
    -- process the position of the buttons
    f.cfScrl.bottom:ClearAllPoints()
    f.cfScrl.up:ClearAllPoints()
    if self.db.profile.position == "RIGHTINSIDE" then
        f.cfScrl.bottom:SetPoint("BOTTOMRIGHT", f.cf, "BOTTOMRIGHT", 0, -4)
        f.cfScrl.up:SetPoint("TOPRIGHT", f.cf, "TOPRIGHT", 0, -4)
    elseif self.db.profile.position == "RIGHTOUTSIDE" then
        f.cfScrl.bottom:SetPoint("BOTTOMLEFT", f.cf, "BOTTOMRIGHT", 0, -4)
        f.cfScrl.up:SetPoint("BOTTOM", f.cfScrl.down, "TOP", 0, -2)
    else
        f.cfScrl.bottom:SetPoint("BOTTOMLEFT", f.cf, "BOTTOMLEFT", -32, -4)
        f.cfScrl.up:SetPoint("BOTTOM", f.cfScrl.down, "TOP", 0, -2)
    end
    -- process the visibility of the buttons
    if visible then
        for k, v in pairs(f.cfScrl) do
            f.cfScrl[k]:Show()
        end
    else
        for k, v in pairs(f.cfScrl) do
            f.cfScrl[k]:Hide()
        end
        if (not f.cf:AtBottom()) and self.db.profile.reminder then
            f.cfreminder:Show()
        else
            f.cfreminder:Hide()
        end
    end
end

function Prat_ChatButtons:MakeReminder(id)
    local cf = getglobal("ChatFrame"..id)
    local b = getglobal("ChatFrame"..id.."ScrollDownReminder") or CreateFrame("Button","ChatFrame"..id.."ScrollDownReminder",cf )
    b:SetFrameStrata("BACKGROUND")
    b:SetWidth(24)
    b:SetHeight(24)
    b:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollEnd-Up")
    b:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollEnd-Down")
    b:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
    b:SetPoint("RIGHT", cf, "RIGHT", 0, 0)
    b:SetPoint("LEFT", cf, "RIGHT", -32, 0)
    b:SetPoint("TOP", cf, "BOTTOM", 0, 28)
    b:SetPoint("BOTTOM", cf, "BOTTOM", 0, 0)
    b:SetScript("OnClick", function() PlaySound("igChatBottom"); this:GetParent():ScrollToBottom() end)
    b:Hide()
end

-- These are some fancy-ish enhacements we can enable
--
-- 1) Alpha to full on mouseover
-- 2) Glowy border on mouseover
-- 3) Automatically adjust right margin so text doesnt overlap the buttons

-- This will add the glow ability that the bottom button has to any button
function Prat_ChatButtons:AddFlashTexture(frame)
    local t = frame:CreateTexture(frame:GetName().."Flash", "OVERLAY")
    t:SetTexture("Interface\\ChatFrame\\UI-ChatIcon-BlinkHilight")
    t:SetPoint("CENTER", frame, "CENTER", 0, 1)
    t:SetBlendMode("ADD")
    t:SetAlpha(0.5)
    t:Hide()
end

-- OnEnter/Exit Handlers for glowy border buttons
function Prat_ChatButtons:GlowBtnOnEnter()
    local flash = getglobal(this:GetName().."Flash");
    flash:Show()
    this:SetAlpha(1.0)
end

function Prat_ChatButtons:GlowBtnOnLeave()
    local flash = getglobal(this:GetName().."Flash");
    flash:Hide()
    this:SetAlpha(self.db.profile.alpha)
end

-- OnEnter/Exit Handlers for alpha hide/unhide buttons
function Prat_ChatButtons:AlphaHideBtnOnEnter()
    this:SetAlpha(1.0)
end

function Prat_ChatButtons:AlphaHideBtnOnLeave()
    this:SetAlpha(self.db.profile.alpha)
end

-- Sample code to show how to flow text around a button which is on the frame
function Prat_ChatButtons:ChatFrame_OnUpdateTextFlow(elapsed)
    self.hooks["ChatFrame_OnUpdate"](elapsed)
    self:ChatMenu(self.db.profile.chatmenu)
    for i = 1,NUM_CHAT_WINDOWS do
        self:ChatButton(i,self.db.profile.chatbutton[i])
    end
    if self.db.profile.showonframe and this == SELECTED_CHAT_FRAME then
        local lines = { this:GetRegions() }
        local cf = getglobal("ChatFrame"..this:GetID())
        local cfup = getglobal("ChatFrame"..this:GetID().."UpButton")
        local cfdown = getglobal("ChatFrame"..this:GetID().."DownButton")
        local cfbottom = getglobal("ChatFrame"..this:GetID().."BottomButton")
        local cfreminder = getglobal("ChatFrame"..this:GetID().."ScrollDownReminder")
        for i=#lines, 1, -1 do
            if lines[i]:GetObjectType() == "FontString" then
                if not(lines[i]:GetTop() > cfup:GetBottom() and lines[i]:GetBottom() < cfup:GetTop() ) then
                    lines[i]:SetPoint("RIGHT", cf, "RIGHT", 0, 0)
                else
                    lines[i]:SetPoint("RIGHT", cfup, "LEFT", 0, 0)
                end
            end
        end
    end
end