﻿--[[
Name: PratGroupJoinNoise
Revision: $Revision: 24018 $
Author(s): Sylvanaar
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#GroupJoinNoise
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that removes the sound and delay caused by people joining/leaving your party/raid on and off (default=off).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratGroupJoinNoise")

L:RegisterTranslations("enUS", function() return {
    ["GroupJoinNoise"] = true,
    ["Removes the sound and delay caused by people joining/leaving your party/raid."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
} end)

L:RegisterTranslations("deDE", function() return {
    ["GroupJoinNoise"] = "Gruppe betreten Ton",
    ["Removes the sound and delay caused by people joining/leaving your party/raid."] = "Ein Modul um den Sound und die Verz\195\182gerrung zu entfernen ausgel\195\182st durch jemanden der deine Gruppe/Schlachtgruppe betritt/verl\195\164sst.",
    ["Toggle"] = "Einschalten",
    ["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
} end)

-- L:RegisterTranslations("koKR", function() return {
-- 	["GroupJoinNoise"] = "파티참여차단",
-- 	["Removes the sound and delay caused by people joining/leaving your party/raid."] = "파티/공격대에 참여/떠남에 의해 발생하는 소리와 지연시간을 차단합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- } end)

L:RegisterTranslations("esES", function() return {
    ["GroupJoinNoise"] = "Ruido de Uni\195\179n a Grupo",
    ["Removes the sound and delay caused by people joining/leaving your party/raid."] = "Un m\195\179dulo que elimina el sonido y retraso causado cuando la gente entra o sale de tu grupo o banda",
    ["Toggle"] = "Activar",
    ["Toggle the module on and off."] = "Activa y desactiva el m\195\179dulo",
} end)

Prat_GroupJoinNoise= Prat:NewModule(Prat:RequestModuleName("PratGroupJoinNoise"))

Prat_GroupJoinNoise.revision = tonumber(string.sub("$Revision: 24018 $", 12, -3))

Prat_GroupJoinNoise.defaultDB = {
    on = true,
}
Prat_GroupJoinNoise.moduleOptions = {}

function Prat_GroupJoinNoise:GetModuleOptions()
    self.moduleOptions = {
        name = L["GroupJoinNoise"],
        desc = L["Removes the sound and delay caused by people joining/leaving your party/raid."],
        type = "group",
        args = {
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("PratGroupJoinNoise") end
            }
        }
    }
   	return self.moduleOptions
end


function Prat_GroupJoinNoise:OnModuleEnable()
    self:Hook("LFGParentFrameTab2_OnClick", true)
end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

function Prat_GroupJoinNoise:LFGParentFrameTab2_OnClick()
	if ( LFGParentFrame:IsShown() ) then
		self.hooks.LFGParentFrameTab2_OnClick()
	end
end